Pl/Controllers/EducationController.cs
using Bll;
using Bll.Extensions;
using Bll.Interfaces;
using Bll.Models;
using Pl.Models;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace Pl.Controllers
{
    /// <summary>
    /// Education controller
    /// </summary>
    [Authorize(Roles = "User")]
    public class EducationController : Controller
    {
        private readonly IEducationService _educationService;
        private readonly IEducationLevelService _educationLevelService;
        public EducationController(IEducationService educationService, IEducationLevelService educationLevelService)
        {
            _educationService = educationService;
            _educationLevelService = educationLevelService;
        }

        public async Task<ActionResult> GetAllEducations()
        {
            return PartialView("AllEducations", await _educationService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        public async Task<ActionResult> RemoveEducation(int id)
        {
            await _educationService.DeleteByIdAsync(id);
            return PartialView("AllEducationsPartial", await _educationService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        public async Task<ActionResult> AddEducation()
        {
            var educationWithLevels = new EducationWithLevels()
            {
                EducationLevelModels = await _educationLevelService.GetAllAsync(),
                EducationModel = new EducationModel()
            };
            return View(educationWithLevels);
        }

        [HttpPost]
        public async Task<ActionResult> AddEducation(EducationWithLevels educationWithLevels)
        {
            if(ModelState.IsValid)
            {
                try
                {
                    educationWithLevels.EducationModel.UserId = User.Identity.GetUserId();
                    await _educationService.AddAsync(educationWithLevels.EducationModel);
                    return RedirectToAction("GetAllEducations");
                }
                catch(CustomException ex)
                {
                    ModelState.AddModelError(ex.ParamName, ex.Message);
                }
            }
            educationWithLevels.EducationLevelModels = await _educationLevelService.GetAllAsync();
            return View(educationWithLevels);
        }

        public async Task<ActionResult> EditEducation(int id)
        {
            var educationWithLevels = new EducationWithLevels()
            {
                EducationModel = await _educationService.GetByIdAsync(id),
                EducationLevelModels = await _educationLevelService.GetAllAsync()
            };
            return View(educationWithLevels);
        }

        [HttpPost]
        public async Task<ActionResult> EditEducation(EducationWithLevels educationWithLevels)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    await _educationService.UpdateAsync(educationWithLevels.EducationModel);
                    return RedirectToAction("GetAllEducations");
                }
                catch (CustomException ex)
                {
                    ModelState.AddModelError(ex.ParamName, ex.Message);
                }
            }
            educationWithLevels.EducationLevelModels = await _educationLevelService.GetAllAsync();
            return View(educationWithLevels);
        }
    }
}

Pl/Controllers/PositionController.cs
using Bll;
using Bll.Interfaces;
using Bll.Models;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace Pl.Controllers
{
    /// <summary>
    /// Position controller
    /// </summary>
    [Authorize(Roles ="Admin")]
    public class PositionController : Controller
    {
        private readonly IPositionService _positionService;
        public PositionController(IPositionService positionService)
        {
            _positionService = positionService;
        }
        public ActionResult CreatePosition()
        {
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> CreatePosition(PositionModel position)
        {
            if(ModelState.IsValid)
            {
                try
                {
                    await _positionService.AddAsync(position);
                    return RedirectToAction("Main", "Summary");
                }
                catch(CustomException ex)
                {
                    ModelState.AddModelError(ex.ParamName, ex.Message);
                }
            }
            return View(position);
        }
    }
}

Pl/Controllers/SummaryController.cs
using Bll.Extensions;
using Bll.Interfaces;
using Bll.Models;
using Pl.Models;
using PagedList;
using Rotativa;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace Pl.Controllers
{
    /// <summary>
    /// Summary controller
    /// </summary>
    [Authorize]
    public class SummaryController : Controller
    {
        private readonly ISummaryService _summaryService;
        private readonly IPositionService _positionService;
        private readonly IUserService _userService;
        private readonly IEducationService _educationService;
        private readonly IWorkExperienceService _workExperienceService;
        public SummaryController(ISummaryService summaryService, IUserService userService, IPositionService positionService,
            IEducationService educationService, IWorkExperienceService workExperienceService)
        {
            _summaryService = summaryService;
            _userService = userService;
            _positionService = positionService;
            _educationService = educationService;
            _workExperienceService = workExperienceService;
        }

        [AllowAnonymous]
        public async Task<ActionResult> Main(int page=1, IEnumerable<int> positionIds=null)
        {
            int pageSize = 4;
            var userWithSummaries = await _summaryService.GetAvailableSummariesByPositionIdAsync(positionIds);
            ViewBag.Positions = await _positionService.GetAllAsync();
            ViewBag.PositionIds = positionIds;
            return View(userWithSummaries.ToPagedList(page, pageSize));
        }

        public async Task<ActionResult> PrintSummaryToPdf(int id)
        {
            var summary = await _summaryService.GetByIdAsync(id);
            var userWithSummary = new UserWithSummary()
            {
                UserModel = await _userService.GetUserByIdAsync(summary.UserId),
                SummaryModel = summary
            };
            return new ViewAsPdf("SummaryToPrint", userWithSummary);
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> ShowSummariesByEducationId(int id)
        {
            return PartialView("SummariesListPartial", await _summaryService.GetAllByEducationIdAsync(User.Identity.GetUserId(), id));
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> ShowSummariesByWorkExperienceId(int id)
        {
            return PartialView("SummariesListPartial", await _summaryService.GetAllByWorkIdAsync(User.Identity.GetUserId(), id));
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> ShowUserSummaries()
        {
            return View("AllSummaries", await _summaryService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        [Authorize(Roles = "User")]
        public ActionResult CreateNewSummary()
        {
            return RedirectToAction("ChangeProfileAjax", "User");
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> AddSummaryAjax()
        {
            var userId = User.Identity.GetUserId();
            var fullSummary = new FullSummary()
            {
                Positions = await _positionService.GetAllAsync(),
                Educations=await _educationService.GetAllByUserIdAsync(userId),
                WorkExperiences=await _workExperienceService.GetAllByUserIdAsync(userId),
                Summary=new SummaryModel()
            };
            return PartialView("AddSummaryPartialAjax", fullSummary);
        }

        [Authorize(Roles = "User")]
        [HttpPost]
        public async Task<ActionResult> AddSummary(FullSummary fullSummary)
        {
            if (!ModelState.IsValid)
            {
                var userId = User.Identity.GetUserId();
                fullSummary.Positions = await _positionService.GetAllAsync();
                fullSummary.Educations = await _educationService.GetAllByUserIdAsync(userId);
                fullSummary.WorkExperiences = await _workExperienceService.GetAllByUserIdAsync(userId);
                return PartialView("AddSummaryPartialAjax", fullSummary);
            }
            else
            {
                fullSummary.Summary.UserId = User.Identity.GetUserId();
                await _summaryService.CreateFullSummaryAsync(fullSummary.Summary, fullSummary.EducationIds, fullSummary.WorkExperienceIds);
                return PartialView("AddSuccess");
            }
        }

        [AllowAnonymous]
        public async Task<ActionResult> GetSummaryDetails(int id)
        {
            var summary = await _summaryService.GetByIdAsync(id);
            var userWithSummary = new UserWithSummary()
            {
                UserModel = await _userService.GetUserByIdAsync(summary.UserId),
                SummaryModel = summary
            };
            return View("SummaryDetails", userWithSummary);
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> RemoveSummary(int id)
        {
            await _summaryService.DeleteByIdAsync(id);
            return PartialView("SummariesListPartial", await _summaryService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> RestoreSummary(int id)
        {
            await _summaryService.RestoreSummaryAsync(id);
            return PartialView("SummariesListPartial", await _summaryService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> HideSummary(int id)
        {
            await _summaryService.HideSummaryAsync(id);
            return PartialView("SummariesListPartial", await _summaryService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        [Authorize(Roles = "User")]
        public async Task<ActionResult> EditSummary(int id)
        {
            var userId = User.Identity.GetUserId();
            var summary = await _summaryService.GetByIdAsync(id);
            var fullSummary = new FullSummary()
            {
                Summary = summary,
                Positions = await _positionService.GetAllAsync(),
                Educations = await _educationService.GetAllByUserIdAsync(userId),
                WorkExperiences = await _workExperienceService.GetAllByUserIdAsync(userId),
                EducationIds= summary.Educations.Select(i=>i.Id),
                WorkExperienceIds = summary.WorkExperiences.Select(i => i.Id)
            };
            return View(fullSummary);
        }

        [Authorize(Roles = "User")]
        [HttpPost]
        public async Task<ActionResult> EditSummary(FullSummary fullSummary)
        {
            if(ModelState.IsValid)
            {
                await _summaryService.UpdateFullSummaryAsync(fullSummary.Summary, fullSummary.EducationIds, fullSummary.WorkExperienceIds);
                return RedirectToAction("ShowUserSummaries");
            }
            else
            {
                var userId = User.Identity.GetUserId();
                fullSummary.Positions = await _positionService.GetAllAsync();
                fullSummary.Educations = await _educationService.GetAllByUserIdAsync(userId);
                fullSummary.WorkExperiences = await _workExperienceService.GetAllByUserIdAsync(userId);
                return View(fullSummary);
            }
        }

        [Authorize(Roles = "Employer")]
        public async Task<ActionResult> GetUserFavorites()
        {
            return View("Favorites", await _summaryService.GetAvailableSummariesFromFavorites(User.Identity.GetUserId()));
        }

        [Authorize(Roles = "Employer")]
        public async Task<ActionResult> AddToFavorites(int id)
        {
            await _summaryService.AddToFavorites(id, User.Identity.GetUserId());
            return RedirectToAction("GetSummaryDetails", new { id });
        }

        [Authorize(Roles = "Employer")]
        public async Task<ActionResult> RemoveFromFavorites(int id)
        {
            await _summaryService.RemoveFromFavorites(id, User.Identity.GetUserId());
            return RedirectToAction("GetSummaryDetails", new { id });
        }
    }
}

Pl/Controllers/WorkExperienceController.cs
using Bll;
using Bll.Extensions;
using Bll.Interfaces;
using Bll.Models;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace Pl.Controllers
{
    /// <summary>
    /// Work Experience controller
    /// </summary>
    [Authorize(Roles = "User")]
    public class WorkExperienceController : Controller
    {
        private readonly IWorkExperienceService _workExperienceService;
        public WorkExperienceController(IWorkExperienceService workExperienceService)
        {
            _workExperienceService = workExperienceService;
        }
        public async Task<ActionResult> GetAllWorkExperiences()
        {
            return PartialView("AllWorkExperiences", await _workExperienceService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        public ActionResult AddWorkExperience()
        {
            return View(new WorkExperienceModel());
        }

        public async Task<ActionResult> RemoveWorkExperience(int id)
        {
            await _workExperienceService.DeleteByIdAsync(id);
            return PartialView("AllWorkExperiencesPartial", await _workExperienceService.GetAllByUserIdAsync(User.Identity.GetUserId()));
        }

        [HttpPost]
        public async Task<ActionResult> AddWorkExperience(WorkExperienceModel workExperienceModel)
        {
            if(ModelState.IsValid)
            {
                try
                {
                    workExperienceModel.UserId = User.Identity.GetUserId();
                    await _workExperienceService.AddAsync(workExperienceModel);
                    return RedirectToAction("GetAllWorkExperiences");
                }
                catch(CustomException ex)
                {
                    ModelState.AddModelError(ex.ParamName, ex.Message);
                }
            }
            return View(workExperienceModel);
        }

        public async Task<ActionResult> EditWorkExperience(int id)
        {
            return View(await _workExperienceService.GetByIdAsync(id));
        }

        [HttpPost]
        public async Task<ActionResult> EditWorkExperience(WorkExperienceModel workExperienceModel)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    await _workExperienceService.UpdateAsync(workExperienceModel);
                    return RedirectToAction("GetAllWorkExperiences");
                }
                catch (CustomException ex)
                {
                    ModelState.AddModelError(ex.ParamName, ex.Message);
                }
            }
            return View(workExperienceModel);
        }
    }
}

Pl/Views/Summary/AddSuccess.cshtml
<div class="d-flex flex-column w-100 align-items-center mt-5">
    <div class="d-flex flex-row">
        <div class="d-flex spinner-grow text-success" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="d-flex">
            <h2>Summary added successfully</h2>
        </div>
    </div>
    <div class="d-flex w-100 justify-content-center">
        @Html.ActionLink("My Summaries", "ShowUserSummaries", "Summary", null, new { @class = "btn btn-outline-success" })
    </div>
</div>

    

Pl/Views/Summary/AddSummaryPartialAjax.cshtml
@model Pl.Models.FullSummary

@using (Ajax.BeginForm("AddSummary", "Summary", new AjaxOptions() { UpdateTargetId = "SummaryCreationId", HttpMethod = "POST" }, new { @class = "control-label col-md-2 w-75 d-flex justify-content-center" }))
{
<div class="w-100 d-flex justify-content-center flex-column">
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })

    <div class="mb-3">
        @Html.LabelFor(model => model.Summary.PositionId, "Select Position", htmlAttributes: new { @class = "control-label col-md-2 w-100" })
        <div class="col-md-10 w-100">
            <select class="form-select form-select-lg mb-3" name="Summary.PositionId" required>
                @foreach (var item in Model.Positions)
                {
                    if (Model.Summary?.PositionId == item.Id)
                    {
                        <option value="@item.Id" selected>@item.Name</option>
                    }
                    else
                    {
                        <option value="@item.Id">@item.Name</option>
                    }
                }
            </select>
        </div>
    </div>

    <div class="mb-3">
        @Html.LabelFor(model => model.Summary.Description, "Description", htmlAttributes: new { @class = "control-label col-md-2 w-100" })
        <div class="col-md-10 w-100">
            @Html.TextAreaFor(model => model.Summary.Description, new { @class = "form-control w-100 text-area-feed" })
            @Html.ValidationMessageFor(model => model.Summary.Description, "", new { @class = "text-danger" })
        </div>
    </div>
    <div class="d-flex w-100 justify-content-center">
        <h2 class="d-flex">Educations</h2>
    </div>

    <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#educationModal">
        Add Education
    </button>

    <!-- Modal -->
    <div class="modal fade" id="educationModal" tabindex="-1" aria-labelledby="educationModal" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="educationModal">Modal title</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body" id="AjaxEduFormId">
                    <p>Entered data will not be saved</p>
                    <div>
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                        @Html.ActionLink("Continue", "AddEducation", "Education", null, new { @class = "btn btn-primary" })
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="w-100" id="AttachEducationToSummaryId">
        @{Html.RenderPartial("~/Views/Education/AttachEducationToSummaryPartialAjax.cshtml", (Model.Educations, Model.EducationIds));}
    </div>
    <div class="d-flex w-100 justify-content-center">
        <h2 class="d-flex">Work Experiences</h2>
    </div>

    <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#workModal">
        Add Work Experience
    </button>

    <!-- Modal -->
    <div class="modal fade" id="workModal" tabindex="-1" aria-labelledby="workModal" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="workModal">Modal title</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <p>Entered data will not be saved</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                    @Html.ActionLink("Continue", "AddWorkExperience", "WorkExperience", null, new { @class = "btn btn-primary" })
                </div>
            </div>
        </div>
    </div>

    <div class="w-100 mb-2" id="AttachWorkExperienceToSummaryId">
        @{ Html.RenderPartial("~/Views/WorkExperience/AttachWorkExperienceToSummaryPartialAjax.cshtml", (Model.WorkExperiences, Model.WorkExperienceIds)); }
    </div>

    <div class="d-flex justify-content-center mb-2">
        <button type="submit" class="btn btn-primary d-flex">Create</button>
    </div>
</div>
}

Pl/Views/Summary/AllSummaries.cshtml
@model IEnumerable<Bll.Models.SummaryModel>

@{
    ViewBag.Title = "All Summaries";
}

<div class="d-flex flex-column w-100 align-items-center">
    <div class="d-flex w-100 justify-content-center">
        <h2 class="d-flex">My Summaries</h2>
    </div>
    <div class="d-flex w-100 justify-content-center mb-2">
        @Html.ActionLink("Add Summary", "CreateNewSummary", "Summary", null, new { @class = "btn btn-primary" })
    </div>
    <div id="SummariesListPartialId" class="w-100">
        @{Html.RenderPartial("SummariesListPartial", Model);}
    </div>
</div>

Pl/Views/Summary/EditSummary.cshtml
@model Pl.Models.FullSummary

@{
    ViewBag.Title = "Edit Summary";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="d-flex flex-column w-100 align-items-center">
    <div class="d-flex w-100 justify-content-center">
        <h2 class="d-flex">Edit</h2>
    </div>
    <div id="SummaryCreationId" class="w-100 d-flex justify-content-center">
        @using (Html.BeginForm("EditSummary", "Summary", FormMethod.Post, new { @class = "control-label col-md-2 w-75 d-flex justify-content-center" }))
        {
        <div class="w-100 d-flex justify-content-center flex-column">
            <hr />
            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
            @Html.HiddenFor(model => model.Summary.CreationDate)
            @Html.HiddenFor(model => model.Summary.IsHidden)
            @Html.HiddenFor(model => model.Summary.UserId)
            @Html.HiddenFor(model => model.Summary.Id)
            <div class="mb-3">
                @Html.LabelFor(model => model.Summary.PositionId, "Select Position", htmlAttributes: new { @class = "control-label col-md-2 w-100" })
                <div class="col-md-10 w-100">
                    <select class="form-select form-select-lg mb-3" name="Summary.PositionId" required>
                        @foreach (var item in Model.Positions)
                        {
                            if (Model.Summary?.PositionId == item.Id)
                            {
                                <option value="@item.Id" selected>@item.Name</option>
                            }
                            else
                            {
                                <option value="@item.Id">@item.Name</option>
                            }
                        }
                    </select>
                </div>
            </div>

            <div class="mb-3">
                @Html.LabelFor(model => model.Summary.Description, "Description", htmlAttributes: new { @class = "control-label col-md-2 w-100" })
                <div class="col-md-10 w-100">
                    @Html.TextAreaFor(model => model.Summary.Description, new { @class = "form-control w-100 text-area-feed" })
                    @Html.ValidationMessageFor(model => model.Summary.Description, "", new { @class = "text-danger" })
                </div>
            </div>
            <div class="d-flex w-100 justify-content-center">
                <h2 class="d-flex">Educations</h2>
            </div>

            <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#educationModal">
                Add Education
            </button>

            <!-- Modal -->
            <div class="modal fade" id="educationModal" tabindex="-1" aria-labelledby="educationModal" aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="educationModal">Modal title</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body" id="AjaxEduFormId">
                            <p>Entered data will not be saved</p>
                            <div>
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                                @Html.ActionLink("Continue", "AddEducation", "Education", null, new { @class = "btn btn-primary" })
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-100" id="AttachEducationToSummaryId">
                @{Html.RenderPartial("~/Views/Education/AttachEducationToSummaryPartialAjax.cshtml", (Model.Educations, Model.EducationIds));}
            </div>
            <div class="d-flex w-100 justify-content-center">
                <h2 class="d-flex">Work Experiences</h2>
            </div>

            <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#workModal">
                Add Work Experience
            </button>

            <!-- Modal -->
            <div class="modal fade" id="workModal" tabindex="-1" aria-labelledby="workModal" aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="workModal">Modal title</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            <p>Entered data will not be saved</p>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                            @Html.ActionLink("Continue", "AddWorkExperience", "WorkExperience", null, new { @class = "btn btn-primary" })
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-100 mb-2" id="AttachWorkExperienceToSummaryId">
                @{ Html.RenderPartial("~/Views/WorkExperience/AttachWorkExperienceToSummaryPartialAjax.cshtml", (Model.WorkExperiences, Model.WorkExperienceIds)); }
            </div>

            <div class="d-flex justify-content-center mb-2">
                <button type="submit" class="btn btn-primary d-flex">Save</button>
            </div>
        </div>
        }
    </div>
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Pl/Views/Summary/Favorites.cshtml
@using Bll.Models;
@model IEnumerable<UserWithSummary>

@{
    ViewBag.Title = "Favorites";
}

<div class="w-100">
    @{ Html.RenderPartial("MainSummaryList", Model); }
</div>

Pl/Views/Summary/Main.cshtml
@using PagedList.Mvc;
@using Bll.Models;
@model PagedList.IPagedList<UserWithSummary>

@{
    ViewBag.Title = "Main";
    var positionIds = (IEnumerable<int>)ViewBag.PositionIds;
}

<div class="d-flex w-100 flex-column align-items-center">
    <h2>Summaries</h2>
    <div class="container">
        <div class="row">
            <div class="col-9 border border-1 p-1" id="MainSummariesId">
                @{ Html.RenderPartial("MainSummaryList", Model.AsEnumerable()); }
            </div>
            <div class="col-3 border border-1 h-fit-cont p-1">
                <div class="d-flex justify-content-center flex-column">
                    @using (Html.BeginForm("Main", "Summary", FormMethod.Post))
                    {
                        @Html.AntiForgeryToken()
                        <ul class="list-group mb-3">
                            @foreach (PositionModel item in ViewBag.Positions)
                            {
                                <li class="list-group-item">
                                    @if (positionIds != null && positionIds.Contains(item.Id))
                                    {
                                        <input type="checkbox" id="@item.Id" name="positionIds" value="@item.Id" checked>
                                    }
                                    else
                                    {
                                        <input type="checkbox" id="@item.Id" name="positionIds" value="@item.Id">
                                    }
                                    <label class="ms-2" for="@item.Name}"> @item.Name </label>
                                </li>
                            }
                        </ul>
                        <div class="d-flex justify-content-center mb-2">
                            <button type="submit" class="btn btn-primary d-flex">Search</button>
                        </div>
                    }
                    @if (User.IsInRole("User"))
                    {
                        <div class="d-flex w-100 justify-content-center mb-2">
                            @Html.ActionLink("Add Summary", "CreateNewSummary", "Summary", null, new { @class = "btn btn-primary" })
                        </div>
                    }
                    @if (User.IsInRole("Admin"))
                    {
                        <div class="d-flex w-100 justify-content-center mb-2">
                            @Html.ActionLink("Add Position", "CreatePosition", "Position", null, new { @class = "btn btn-primary" })
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
    <div class="d-flex justify-content-center">
        @Html.PagedListPager(Model, page => Url.Action("Main", new { page, positionIds = ViewBag.PositionIds }))
    </div>
</div>